package com.inca.npbusi.sales.bms_sa_con;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.RecordTrunk;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.DefaultNPParam;
import com.inca.np.util.SendHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.mpcsprodHelper;
import org.apache.log4j.Category;

public class Sa_con_dtl_mde extends CMdeModel {
   private Category a = Category.getInstance(Sa_con_dtl_mde.class);
   private String b = "";
   private String c = "";
   public Sa_con_doc_ste condocste = null;

   public Sa_con_dtl_mde(CFrame var1, String var2) {
      super(var1, var2);
      if (!DefaultNPParam.runonserver) {
         this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
         this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
      }

   }

   protected CMasterModel createMastermodel() {
      return new Sa_con_dtl_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Sa_con_dtl_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "condtlid";
   }

   public String getDetailRelatecolname() {
      return "condtlid";
   }

   public String getSaveCommandString() {
      return "Sa_con_dtl_mde.保存订单细单及货品明细";
   }

   public void setSacondocste(Sa_con_doc_ste var1) {
      this.condocste = var1;
   }

   public Sa_con_doc_ste getSacondocste() {
      return this.condocste;
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("保存")) {
         this.toSave();
         return 0;
      } else {
         return super.on_actionPerformed(var1);
      }
   }

   public void toSave() {
      if (this.getDetailModel().on_beforesave() != -1) {
         super.on_beforesave();
         DBTableModel var1 = this.getMasterModel().getDBtableModel();
         DBTableModel var2 = null;
         String var3 = null;
         boolean var18 = true;
         this.getMasterModel().commitEdit();
         this.getDetailModel().tableChanged();
         this.getDetailModel().commitEdit();

         int var4;
         int var5;
         String var7;
         for(var4 = 0; var4 < var1.getRowCount(); ++var4) {
            if (this.getMasterModel().getdbStatus(var4) != 0) {
               var18 = false;
               var5 = this.getDetailModel().getRowCount();

               for(int var6 = 0; var6 < var5; ++var6) {
                  if (this.getDetailModel().getdbStatus(var6) == 2 || this.getDetailModel().getdbStatus(var6) == 1) {
                     if ((var7 = this.getDetailModel().getItemValue(var6, "lotid")) == null || "".equals(var7)) {
                        this.infoMessage("提示", "批号不为空！");
                        return;
                     }

                     String var8;
                     if ((var8 = this.getDetailModel().getItemValue(var6, "dtlgoodsqty")) == null || "".equals(var8)) {
                        this.infoMessage("提示", "数量不为空！");
                        return;
                     }
                  }
               }
            }
         }

         if (var18) {
            this.infoMessage("提示", "没有数据需要保存！");
         } else {
            for(var4 = 0; var4 < var1.getRowCount(); ++var4) {
               if (var1.getdbStatus(var4) == 2) {
                  String var24 = "0";
                  var7 = null;
                  ClientRequest var26 = new ClientRequest();
                  var3 = null;
                  StringCommand var9 = new StringCommand("销售订单发货:货品明细保存");
                  DataCommand var10 = new DataCommand();
                  DataCommand var11 = new DataCommand();
                  ParamCommand var12 = new ParamCommand();
                  String var22 = null;
                  var3 = var1.getItemValue(var4, "goodsqty");
                  var5 = (var2 = (DBTableModel)this.detaildbmodelmap.get(this.mastermodel.getDBtableModel().getTmppkid(var4))).getRowCount();
                  DBTableModel var25 = this.getDetailModel().getDBtableModel().copyStruct();
                  DBTableModel var13 = var2;
                  if (var2.getRowCount() != 0) {
                     var25.appendRecord(var2.getRecordThunk(0));
                     DBTableModel var14 = this.getDetailModel().getDBtableModel().copyStruct();

                     int var15;
                     for(var15 = var2.getRowCount() - 1; var15 > 0; --var15) {
                        if (var13.getdbStatus(var15) != 3) {
                           var14.appendRecord(var13.getRecordThunk(var15));
                        }
                     }

                     var13 = var14;

                     for(var15 = 1; var15 < var13.getRowCount(); ++var15) {
                        var13.getItemValue(var15, "lotid");
                        var13.getItemValue(var15, "batchid");
                        var13.getItemValue(var15, "posid");
                        var13.getItemValue(var15, "storageid");

                        int var30;
                        for(var30 = 0; var30 < var25.getRowCount(); ++var30) {
                           var25.getItemValue(var30, "lotid");
                           var25.getItemValue(var30, "batchid");
                           var25.getItemValue(var30, "posid");
                           var25.getItemValue(var30, "storageid");
                           var25.getdbStatus(var30);
                        }

                        if (var30 == var25.getRowCount()) {
                           var25.appendRecord(var13.getRecordThunk(var30));
                        }
                     }

                     for(var15 = 0; var15 < var5; ++var15) {
                        var7 = var2.getItemValue(var15, "dtlgoodsqty");
                        if (var2.getdbStatus(var15) != 3) {
                           var24 = DecimalHelper.add(var24, var7, 6);
                        }
                     }

                     String var32 = var1.getItemValue(var4, "accstqty");
                     String var31 = DecimalHelper.sub(var3, var32, 6);
                     var3 = var1.getItemValue(var4, "goodsid");
                     var22 = var1.getItemValue(var4, "goodsname");
                     int var27 = this.condocste.getRow();
                     var7 = this.condocste.getItemValue(var27, "customid");
                     String var29 = "0";
                     var32 = "0";

                     try {
                        DBTableModel var20;
                        var29 = (var20 = NpbusiDBHelper.getAllotqtyinfo(var3, var7)).getItemValue(0, "limitedsaleflag");
                        var32 = var20.getItemValue(0, "allotqty");
                     } catch (Exception var16) {
                        var16.printStackTrace();
                        this.infoMessage("提示", "查询货品可用配额时出错:" + var16.getMessage());
                     }

                     var7 = mpcsprodHelper.getSysProdConfig(var3 = ClientUserManager.getCurrentUser().getEntryid(), "prod202012");
                     if ("1".equals(var7)) {
                        if ("1".equals(var29)) {
                           var7 = var1.getItemValue(var4, "condtlid");
                           var29 = "0";
                           if (var7 != null && var7.trim().length() != 0) {
                              var31 = this.a(var7);
                              if (DecimalHelper.toDec(var24).compareTo(DecimalHelper.toDec(var31)) > 0) {
                                 var29 = DecimalHelper.sub(var24, var31, 6);
                              }
                           } else {
                              var29 = var24;
                           }

                           if (DecimalHelper.toDec(var32).compareTo(DecimalHelper.toDec(var29)) < 0) {
                              this.infoMessage("提示", "货品" + var22 + "为配额销售货品，当前可用配额为" + var32 + "，\n本次增加的分配额为" + var29 + "已经超过了可用配额，请检查!");
                              return;
                           }
                        }
                     } else {
                        if (DecimalHelper.toDec(var24).compareTo(DecimalHelper.toDec(var31)) > 0) {
                           this.warnMessage("警告", "货品明细数量总和不能大于订单的可分配数量!");
                           return;
                        }

                        if ("1".equals(var29)) {
                           var7 = var1.getItemValue(var4, "condtlid");
                           var29 = "0";
                           if (var7 != null && var7.trim().length() != 0) {
                              var31 = this.a(var7);
                              if (DecimalHelper.toDec(var24).compareTo(DecimalHelper.toDec(var31)) > 0) {
                                 var29 = DecimalHelper.sub(var24, var31, 6);
                              }
                           } else {
                              var29 = var24;
                           }

                           if (DecimalHelper.toDec(var32).compareTo(DecimalHelper.toDec(var29)) < 0) {
                              this.infoMessage("提示", "货品" + var22 + "为配额销售货品，当前可用配额为" + var32 + "，\n本次增加的分配额为" + var29 + "已经超过了可用配额，请检查!");
                              return;
                           }
                        }
                     }

                     RecordTrunk var28 = var1.getRecordThunk(var4);
                     var13 = this.mastermodel.getDBtableModel().copyStruct();
                     var14 = null;
                     var13.appendRecord(var28);
                     var10.setDbmodel(var13);
                     var11.setDbmodel(var2);
                     var26.addCommand(var9);
                     var26.addCommand(var10);
                     var26.addCommand(var11);
                     ClientUserManager.getCurrentUser().getDeptid();
                     var12.addParam("entryid", var3);
                     var26.addCommand(var12);

                     try {
                        ServerResponse var21;
                        if (!((StringCommand)(var21 = SendHelper.sendRequest(var26)).commandAt(0)).getString().startsWith("+OK")) {
                           this.infoMessage("提示", "保存失败，原因为验证库存失败！");
                           return;
                        }

                        var31 = ((ParamCommand)var21.commandAt(1)).getValue("saplaceqty");
                        this.getMasterModel().setItemValue(var4, "saplaceqty", var31);
                        if (DecimalHelper.toDec(var24).compareTo(DecimalHelper.toDec(var31)) > 0) {
                           this.infoMessage("友好提示", "可销库存不足的明细信息被删除！");
                        }

                        int var23 = this.getMasterModel().getRow();
                        var3 = this.getMasterModel().getItemValue(var23, "condtlid");
                        var3 = "select * from bms_sa_con_goodsdtl_v where condtlid=" + var3;
                        var2.doRetrieve(var3, 999);
                        this.detailmodel.tableChanged();
                        String var19 = "0";

                        for(var23 = 0; var23 < this.detailmodel.getRowCount(); ++var23) {
                           var22 = this.detailmodel.getItemValue(var23, "dtlgoodsqty");
                           var19 = DecimalHelper.add(var19, var22, 6);
                        }

                        var3 = DecimalHelper.sub(this.mastermodel.getItemValue(var4, "goodsqty"), var19, 6);
                        this.mastermodel.setItemValue(var4, "saplaceqty", var19);
                        this.mastermodel.setItemValue(var4, "plansaplaceqty", var3);
                        this.getMasterModel().setdbStatus(var4, 0);
                        this.getMasterModel().tableChanged();
                     } catch (Exception var17) {
                        this.warnMessage("警告", "保存失败!");
                        this.a.error("箱号维护：货品明细保存失败", var17);
                        return;
                     }
                  }
               }
            }

            this.mastermodel.doRequery();
            this.mastermodel.tableChanged();
            this.detailmodel.tableChanged();
         }
      }
   }

   private String a(String var1) {
      String var2 = "select goodsid,saplaceqty,accstqty from bms_sa_con_dtl where condtlid=" + var1;
      RemotesqlHelper var3 = new RemotesqlHelper();
      String var4 = "0";

      try {
         DBTableModel var6;
         if ((var6 = var3.doSelect(var2, 0, 1)) == null || var6.getRowCount() <= 0) {
            this.infoMessage("提示", "没有找到ID=" + var1 + "的销售订单细单");
            return null;
         }

         var1 = var6.getItemValue(0, "saplaceqty");
         var2 = var6.getItemValue(0, "accstqty");
         var4 = DecimalHelper.sub(var1, var2, 6);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      return var4;
   }

   public String getEntryid() {
      return this.b;
   }

   public void setEntryid(String var1) {
      this.b = var1;
   }

   public String getEntryname() {
      return this.c;
   }

   public void setEntryname(String var1) {
      this.c = var1;
   }

   protected boolean isAllownodetail() {
      return true;
   }
}
